public class myBox {
  color myCol, myStr;
  int myIdentity;
  float [] myPos = {0,0,0}, myVel = {0,0,0}, mySize = {0,0,0}, myScreenPos = {0,0,2};
  float mySrf = 0.0;
  float[] formula;
  String[] myProp; //   Name, ConnectedTo, MinToShowConn, Strenght
  int[] myConnections; String myConnectionText; float myMinToShowConn;
  boolean pinned = false, hidden = false;
  int oroSectorX = 0, oroSectorZ = 0;
  float lightLevel;
  
  myBox (float[] p, color c, color s, String[] o, int i){
    myIdentity=i;
    myProp=o;
    formula = float(split(myProp[3],','));
    
    updateSize();
    
    myPos=p;
    myCol=c;
    myStr=s;
    myConnectionText=myProp[1];
    readMyConnectionText();
    myMinToShowConn = float(myProp[2]);
    lightLevel = float(myProp[4]);
  }

private void updatePosition(){
   if(!hidden){
     
     if(checkBorders)
       avoidScreenCrossing();
    
     if (!pinned){
         //update the position
         myPos[0] += myVel[0];
         myPos[1] += myVel[1];
         
         if(threeD)
          myPos[2] += myVel[2];
         }
    
    
      oroSectorX = searchBox(myPos[0]-oroMinX,oroSpaceX,orographyWidth-2);
      oroSectorZ = searchBox(myPos[2]-oroMinZ,oroSpaceZ,orographyDepth-2);
    
      getLevelOnMesh(oroSectorX,oroSectorZ,myPos[0],myPos[2]);
     
  
     }
  }

  void readMyConnectionText(){
    myConnections=int(split(myConnectionText, ','));
    if(myConnections[0]==-1) myConnections=shorten(myConnections);
}

  void setVel(float a, float b, float c){
    myVel[0] = a;
    myVel[1] = b;
    myVel[2] = c;
  }

  void setPos(float a, float b, float c){
   if(!pinned){
    myPos[0] = a;
    myPos[1] = b;
    myPos[2] = c;
   }
  }
  
  void findForces(){
    if(!hidden){
     float[] myTempForce = new float[3];
   
       for(int h=0; h<myConnections.length; h++){
        
        //normalize the vector Force
        myTempForce = normalize(getDistVector(myConnections[h],myIdentity));
               
        myTempForce = multiplyVector(myTempForce,-(visualInterface[1].getMyValue()*10.0-getDist(myConnections[h],myIdentity))/myConnections.length);
                
         if (!pinned)
           myVel = interpolate(myVel,myTempForce,0.01);
         if (!elementInstances[myConnections[h]].pinned)
           elementInstances[myConnections[h]].myVel = interpolate(elementInstances[myConnections[h]].myVel,multiplyVector(myTempForce,-1.0),0.01);
       }
     }
  }


 void updateSize(){
    
    if(visualInterface[2].inUse){
      
    mySrf = readFormula();
    
    mySize[0]=sqrt(mySrf*3.0/2.0)/2.0*drawingScale;
    if(mySrf > 25.0)
      mySize[1]=8.0/2.0*drawingScale;
    else if(mySrf > 25.0)
      mySize[1]=5.0/2.0*drawingScale;
    else
      mySize[1]=3.0/2.0*drawingScale;
      
    mySize[2]=mySize[0]*2.0/3.0;
    }else{
    mySize[0]=15.0/2.0*drawingScale;
    mySize[1]=10.0/2.0*drawingScale;
    mySize[2]=10.0/2.0*drawingScale;
    }
}

 void updateVisibility(){
    if(myMinToShowConn<visualInterface[0].myValue)
       hidden = true;
    else if(myMinToShowConn>=visualInterface[0].myValue)
       hidden = false;
   }

void updateScreenPos(){
         myScreenPos[0] = screenX(myPos[0],myPos[1],myPos[2]);
         myScreenPos[1] = screenY(myPos[0],myPos[1],myPos[2]);
         myScreenPos[2] = screenZ(myPos[0],myPos[1],myPos[2]);
  }

 void drawLines(){
    if(!hidden){
    
      
    //EXPORT TYPE RCL
    if(export && exportType == 0){
    for(int h=0; h<myConnections.length; h++){
           exportBezier(myPos[0], myPos[1]-mySize[1]-5.0, myPos[2],
           myPos[0], myPos[1]-mySize[1]-10.0, myPos[2],
           elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+10.0, elementInstances[myConnections[h]].myPos[2],
           elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+5.0, elementInstances[myConnections[h]].myPos[2]);
    }} else {
      
      
    //add the connecting lines
    for(int h=0; h<myConnections.length; h++){
     
       //x1, y1, z1, cx1, cy1, cz1, cx2, cy2, cz2, x2, y2, z2
       if(threeD)
        bezier(myPos[0], myPos[1]-mySize[1]-5, myPos[2],
        myPos[0], myPos[1]-mySize[1]-45.0, myPos[2],
        elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+45.0, elementInstances[myConnections[h]].myPos[2],
        elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+5.0, elementInstances[myConnections[h]].myPos[2]);
      else
        bezier(myPos[0], myPos[1]-mySize[1]-5.0,
        myPos[0], myPos[1]-mySize[1]-45.0,
        elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+45.0,
        elementInstances[myConnections[h]].myPos[0], elementInstances[myConnections[h]].myPos[1]+elementInstances[myConnections[h]].mySize[1]+5.0);
     }    
    }
}}

 void drawBox(){
     if(!hidden){
       
    //EXPORT TYPE RCL
    if(export && exportType == 0)
      exportBox(myPos[0],myPos[1],myPos[2],mySize[0],mySize[1],mySize[2]);
    
    
    
        //define the color of the box
        if(selIndex == myIdentity)
          fill(mySel);
        if(pinned){
         fill(myPin); 
         }
        
    
    if(threeD){
    
    pushMatrix();
    translate(myPos[0],myPos[1],myPos[2]);
    box(mySize[0]*2,mySize[1]*2,mySize[2]*2);
    popMatrix();
    
     }  else {
       
     beginShape();
     vertex(myPos[0]-mySize[0], myPos[1]-mySize[1], 0);
     vertex(myPos[0]+mySize[0], myPos[1]-mySize[1], 0);
     vertex(myPos[0]+mySize[0], myPos[1]+mySize[1], 0);
     vertex(myPos[0]-mySize[0], myPos[1]+mySize[1], 0);
     endShape(CLOSE);
     }
     
        if(selIndex == myIdentity || pinned)
          fill(myCol);
     
  }
 }
 
 void thingsWhenSelected(){
     if(executing && threeD && drawOrography>0){
     //DRAW PROJECTION ON OROGRAPHY
     fill(oroSel);
     beginShape(QUADS);
        vertex(orography[oroSectorX][oroSectorZ][0], orography[oroSectorX][oroSectorZ][1], orography[oroSectorX][oroSectorZ][2]);
        vertex(orography[oroSectorX+1][oroSectorZ][0], orography[oroSectorX+1][oroSectorZ][1], orography[oroSectorX+1][oroSectorZ][2]);
        vertex(orography[oroSectorX+1][oroSectorZ+1][0], orography[oroSectorX+1][oroSectorZ+1][1], orography[oroSectorX+1][oroSectorZ+1][2]);
        vertex(orography[oroSectorX][oroSectorZ+1][0], orography[oroSectorX][oroSectorZ+1][1], orography[oroSectorX][oroSectorZ+1][2]);
     endShape(CLOSE);
     }
     
     
     fill(myTxt);
     //ADD MY NUMBER TO THE BOX
     text(myIdentity, round(myPos[0]-28), round(myPos[1]-24), myPos[2]);
     
     if(pinned)
      text("X", myPos[0]+28, myPos[1]-24); 
 }
 
 void addTxt(){
    //add the text to the box
    if(!hidden){
     if(myScreenPos[2]>=0.0)
      text(myProp[0], (int)myScreenPos[0], (int)myScreenPos[1], threeD?(int)myScreenPos[2]:0);
    }
 }

 void getBoxInfo(){
    text("- status -", width-35, 20);
    text("num:  "+nfs(myIdentity,3), width-35, 30);
    text("vis: "+!hidden, width-35, 40);
    text("pin: "+pinned, width-35, 50);
    text(""+round(mySize[0]*2.0*10.0/drawingScale)/10.0+"x "+round(mySize[1]*2.0*10.0/drawingScale)/10.0+"x "+round(mySize[2]*2.0*10.0/drawingScale)/10.0, width-35, 60);
    text(int(myPos[0]*drawingScale)+","+int(myPos[1]*drawingScale)+","+int(myPos[2]*drawingScale), width-35, 70);
    text(int(myVel[0]*100)+","+int(myVel[1]*100)+","+int(myVel[2]*100), width-35, 80);
}


private float readFormula(){
  
  switch (formula.length){
    case 0:
      return visualInterface[2].getMyValue();
    case 1:
      return formula[0];
    case 2:
      return formula[0]+formula[1]*visualInterface[2].getMyValue();
    case 3:
      return formula[0]+formula[1]/formula[2]*visualInterface[2].getMyValue();
    case 4:
      return formula[0]+pow(formula[1]/formula[2]*visualInterface[2].getMyValue(),formula[3]);
    case 5:
      return formula[0]+pow(formula[1]/formula[2]*visualInterface[2].getMyValue(),formula[3]/formula[4]);
    default:
      return 100.0;
  }
}

private void avoidScreenCrossing(){
    //Avoids overcrossing of the box: width x width x height
      if(myPos[0]>width-mySize[0]){
        myPos[0]=width-mySize[0];
        myVel[0]=myVel[0]*-1;
      }
      if(myPos[0]<mySize[0]){ 
        myPos[0]=mySize[0]+1;
        myVel[0]=myVel[0]*-1;
      }
      if(myPos[1]>height-mySize[1]){
        myPos[1]=height-mySize[1]-1;
        myVel[1]=myVel[1]*-1;
      }
      if(myPos[1]<mySize[1]){
        myPos[1]=mySize[1]+1;
        myVel[1]=myVel[1]*-1;
      } 
      if(myPos[2]>0){
        myPos[2]=1;
        myVel[2]=myVel[2]*-1;
      } 
      if(myPos[2]<-width){
        myPos[2]=-width-1;
        myVel[2]=myVel[2]*-1;
      }
  
  }

private void initializeVelocity(){
   //Makes velocity == 6
   myVel = multiplyVector(normalize(myVel),6.0);
  }
  
private void stopVelocity(){
   //Makes velocity == 0
  
      myVel[0] = 0.0;
      myVel[1] = 0.0;
      myVel[2] = 0.0;
  }

}


//(c) Giulio Piacentino 2008. Some rights reserved.
