boolean saveMyNewFile = false;

float[][][] orography; //array[row][col] of 3D[]={x,y,z} points;
int orographyDepth, orographyWidth;  //If both are == 0 the program tries to guess which one is the right size of the rectangle, using the parameter tolerance
float oroMinX, oroMaxX, oroMinY, oroMaxY, oroMinZ, oroMaxZ; float oroRangeX, oroRangeY, oroRangeZ; float oroSpaceX, oroSpaceZ;
float tolerance; float importScale;
String[] oroSources = {"data\\mountHeights_5000.txt", "data\\mountHeights_2000.txt"};
int oroFileIndex = 0;


int searchBox(float pos, float range, int subDiv){
 int toReturn = int(pos/range);
 if(toReturn > subDiv){
   toReturn = subDiv;
  }else if(toReturn<0){
   toReturn = 0;
  }
 return toReturn;
}


private float getLevelOnMesh(int boxX, int boxZ, float X, float Z){
  float Y;
  Y=0;
  
  

  return Y;
}


//------------------------------------
//ROUTINES TO LOAD THE FILE START HERE
//------------------------------------


float[][][] loadMountainFile(){
  
 String[] myOrographyStrings;
 float[][] myOrographyPoints;
 float[][][] toReturn;
 
 myOrographyStrings = loadStrings(oroSources[oroFileIndex]);
 
 print(oroSources[oroFileIndex]);
 
 //PARSE TEXT
 myOrographyPoints = new float[myOrographyStrings.length][3];
 for(int i=0;i<myOrographyStrings.length;i++)
  myOrographyPoints[i] = float(splitTokens(myOrographyStrings[i],", \""));
  
 //SORT BY POINTS
 myOrographyPoints = sort3DPoints(myOrographyPoints);
 
 //EVENTUALLY SAVE THE PRODUCED FILE
 if(saveMyNewFile){
   for(int i=0;i<myOrographyStrings.length;i++)
     myOrographyStrings[i] = join(str(myOrographyPoints[i]),",");
   saveStrings("data\\mountHeightsAfter.txt", myOrographyStrings);
 }
 
   //LOAD THE WIDTH
  if(orographyWidth==0 && orographyDepth==0){
  float t1, t2;
  t1 = myOrographyPoints[0][0];
  for(orographyWidth=1; orographyWidth<myOrographyPoints.length; orographyWidth++){
    t2 = myOrographyPoints[orographyWidth][0];
     if(tolCompare(t1,t2)!=0)
       break;
 }
 
  orographyDepth = int(floor((myOrographyPoints.length*1.0)/(orographyWidth*1.0)));
 
  if(orographyWidth*orographyDepth != myOrographyPoints.length){
   println("Error: file of points in the file cannot form a rectangle: "+orographyWidth+" * "+orographyDepth+" != "+myOrographyPoints.length);
  }else
   print(" imported: " + orographyWidth + "x"+orographyDepth+" ("+(orographyWidth*orographyDepth)+") points"+((orographyWidth==orographyDepth)?" (square).":"."));
 }else{
   print("You set the model to have " + orographyWidth + "x"+orographyDepth+" ("+(orographyWidth*orographyDepth)+") points."+((orographyWidth==orographyDepth)?" It's therefore a square.":""));
 }
 
 if(orographyWidth*orographyDepth != myOrographyPoints.length)
  println("Error: file of points as you set don't multiply into the total of point you are importing. The tot should be "+orographyWidth*orographyDepth+" but is "+myOrographyPoints.length+".");
 
 toReturn = new float[orographyDepth][orographyWidth][3];
 
 //TRANSFORM THE LINE IN A RECTANGLE
 int row=0, col=0;
 for(int i=0; i<myOrographyPoints.length; i++){

      if(row<=orographyDepth-1 && col<=orographyWidth-1)
       toReturn[row][col] = myOrographyPoints[i];
      else
       println("Error importing file: error 1. I'm trying to set outside the rectangle of the array orography[row][col][3]");
   
    
    //MANAGE THE ADVENCEMENT
    if(col == (orographyWidth-1)){
     col=0;
     row++;
    }else{
     col++;
     }
}

//ADJUST FOR THE PROCESSING SCREEN: FROM XYZ AS IN ANY 3D PROGRAM TO (X-ZY)scaled - PROCESSING
 float T;
 
 for(int i=0; i<orographyDepth; i++){
  for(int j=0; j<orographyWidth; j++){
    toReturn[i][j][0] = toReturn[i][j][0]*importScale*drawingScale;
    T = toReturn[i][j][1];
    toReturn[i][j][1] = 0.0-(toReturn[i][j][2]*importScale*drawingScale);
    toReturn[i][j][2] = T*importScale*drawingScale;
    
    //SET MAX && MIN
    if(i==0&&j==0){
     oroMinX=toReturn[i][j][0]; oroMaxX=toReturn[i][j][0]; oroMinY=toReturn[i][j][1]; oroMaxY=toReturn[i][j][1]; oroMinZ=toReturn[i][j][2]; oroMaxZ=toReturn[i][j][2];
    }else{
     oroMinX=min(toReturn[i][j][0],oroMinX); oroMaxX=max(toReturn[i][j][0],oroMaxX); oroMinY=min(toReturn[i][j][1],oroMinY); oroMaxY=max(toReturn[i][j][1],oroMaxY); oroMinZ=min(toReturn[i][j][2],oroMinZ); oroMaxZ=max(toReturn[i][j][2],oroMaxZ);
    }
  }
 }
  
  oroRangeX=oroMaxX-oroMinX;
  oroRangeY=oroMaxY-oroMinY;
  oroRangeZ=oroMaxZ-oroMinZ;
  
  oroSpaceX=oroRangeX/(orographyWidth-1);
  oroSpaceZ=oroRangeZ/(orographyDepth-1);
  
  
   for(int i=0; i<orographyDepth; i++){
      for(int j=0; j<orographyWidth; j++){
         toReturn[i][j][1] = toReturn[i][j][1]+965.0;
   }}
  
  println(" It measures "+round(oroRangeX/drawingScale)+"x"+round(oroRangeZ/drawingScale)+"x"+round(oroRangeY/drawingScale)+" m. One unit ~"+round(oroSpaceX/drawingScale)+"x"+round(oroSpaceZ/drawingScale)+" m, "+round(oroSpaceX*oroSpaceZ/drawingScale/drawingScale)+" m2.");
   
  return toReturn;
}

 //GIVES -1 IF a>b, 0 if a==b and 1 if a<b
 int arrMagnitudeCompare(float[] a, float[] b){
  
  int totLenght = max(a.length,b.length);
  for(int i=0; i<totLenght; i++){
   if(abs(a[i]-b[i])<tolerance)
     continue;
   else if(a[i]>b[i])
     return -1;
   else
     return 1;  
   }
  
  if(a.length==b.length){
    println("Unexpected event in arrMagnitudeCompare. Two feed arrays are equivalent and of same length.");
    return 0;
  }else if(a.length>b.length)
    return -1;
  return 1;
 }
 
 int tolCompare(float a, float b){
    if(abs(a-b)<tolerance)
     return 0;
   else if(a>b)
     return -1;
   else
     return 1;  
 }

private float[][] sort3DPoints(float[][] a){
 //INSPIRED BY: An Odd-Even Transposition sort demonstration algorithm
 //INSPIRED BY: author Andrew Kitchen
 //INSPIRED BY: version 22 Nov 1995
 
	for (int i = 0; i < a.length/2; i++ ) {
  
		for (int j = 0; j+1 < a.length; j += 2) 
		    if (arrMagnitudeCompare(a[j],a[j+1])<0) { //a[j] > a[j+1]
		        float[] T = a[j];
		        a[j] = a[j+1];
		        a[j+1] = T;
		    }

		for (int j = 1; j+1 < a.length; j += 2) 
		    if (arrMagnitudeCompare(a[j],a[j+1])<0) {
		        float[] T = a[j];
		        a[j] = a[j+1];
		        a[j+1] = T;
		    }
	}
return a;
}
